#!/usr/bin/perl

require "banman10.pl";

##############################################
# MeySoft BannerManager - update.pl
# BASIC PACKAGE - VERSION: 1.0-F
# Copyright (c) 1997 MeySoft
# Author: Jeffrey L. Meyer, Sr.Programmer
# WebMaster@MeySoft.com
###############################################
# THIS SOFTWARE PRODUCT IS LICENSED FOR USE
# ON A SINGLE SERVER ONLY. ANY OTHER USE IS
# IN DIRECT VIOLATION OF US AND INTERNATIONAL
# COPYRIGHT LAWS.
###############################################
# THIS HEADER MUST REMAIN INTACT
##############################################
@slist=split(/,/,$banman10{'slist'});
$owner_email="$banman10{'owner_email'}";
$mail_prog="$banman10{'mail_prog'}";
$send_env=$banman10{'send_env'};
$acct_dir="$banman10{'acct_dir'}";
$acct_num=0;
$encrypt_key="$banman10{'encrypt_key'}";
$return="$banman10{'update_page'}";
$banner_page="$banman10{'banner_page'}";
$member_page="$banman10{'member_page'}";
##############################################
read(STDIN,$data,$ENV{'CONTENT_LENGTH'});
@fields = split(/&/,$data);
foreach $fields(@fields){
  ($field_name,$field_val)=split(/=/,$fields);
  $field_val=~ tr/+/ /;
  $field_val=~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
 $DATA{$field_name}=$field_val;
}

if($DATA{'acct_num'}){
   ($acct_num,$sf)=split(/-/,$DATA{'acct_num'});
   $style=$slist[$sf-1]; 
}else{
 $ext_msg .="Fehlende Account Nummer,";
 &send_form;
}
($bw,$bh)=split(/x/,$style);


#point to last account number
$record_file="$style/last_rec.ord";
##############################
 open (DBASE,"$acct_dir/$style/$acct_num.dat") || &send_error; 
 while($line=<DBASE>){
   ($user,$mail,$passw,$calls,$hits,$linkurl,$curban,$bannerurl,$a_type)=split(/,/,$line);
   $pass="$passw";
   }
 close(DBASE);

if($DATA{'password'}){
 $password="$DATA{'password'}";
}else{
 $ext_msg .="Fehlendes Passwort,";
 &send_form;
}

$pok=0;
&check_pw;
if($pok==1){

if($DATA{'name'}){
 $user="$DATA{'name'}";
}
if($DATA{'email'}){
 $mail="$DATA{'email'}";
}
if($DATA{'bannerurl'}){
 $bannerurl="$DATA{'bannerurl'}";

}

if($DATA{'linkurl'}){
 $linkurl="$DATA{'linkurl'}";
}
$new_pass="$password";

if($DATA{'newpass'} ne ''){
 $new_pass=crypt($DATA{'newpass'},substr($encrypt_key,0,2));
 $passw="$new_pass";
}

$ext_msg="";
if($DATA{'impressions'} eq 'reset'){
$ext_msg .="Bannerimpressionen bis Datum $calls (reset) ";
$calls=0;
}
if($DATA{'hits'} eq 'reset'){
$ext_msg .="Hits bis Datum $hits (reset)";
$hits=0;
}
open (DB,">$acct_dir/$style/$acct_num.dat") || &send_error;
print DB   "$user,$mail,$passw,$calls,$hits,$linkurl,$curban,$bannerurl,$a_type";
close(DB);

#DELETE ACCOUNT?
if($DATA{'delete'} eq 'YES'){
&delete_acct;
}
&notify;
&send_page;
}else{
  $ext_msg .="Falsches Passwort,";
  &send_form;
}
exit;

sub send_error {
 print "Content-type: text/html\n\n";
 print "<HEAD><TITLE>Banner Ad Update</TITLE></HEAD><BODY>\n";
 print "Fehler im Formular. Bitte eingegebene Daten korrigieren.<BR>\n";
 print "Error Meldung: $! Fr Account: \'$acct_num\'\n";
 print "<HR SIZE=3 NOSHADE>\n";
 print "<A href=\"$return\">Zurck zum Formular</a>\n";
 print "</BODY>\n";
exit;
}

sub send_page {
 print "Content-type: text/html\n\n";
 print "<HEAD><TITLE>Banner Ad Update</TITLE></HEAD><BODY bgcolor=\"ffffff\">\n";
if($DATA{'delete'} eq 'YES'){
 print "Dein Account wurde gelscht.\n";
}else{
 print "Banner Ad Statistik fr Account Nr: $acct_num <P>\n";
 print "Name: $user <BR>\n";
 print "E-Mail: $mail <BR>\n";
if(($DATA{'newpass'} ne '')&&($password ne $DATA{'newpass'})){
 print"Passwort: $DATA{'newpass'}<BR>\n";
}else{
 print "Passwort: $password <BR>\n";
}
 print "Banner URL: $bannerurl<BR>\n";
 print "Link URL: $linkurl<BR>\n";
 print "Account Typ: $a_type<BR>\n";
 print "Gesamte Impressionen: $calls<BR>\n";
 print "Bannerklicks: $hits<BR>\n";
 print "<HR SIZE=3 NOSHADE>\n";
 print "<a href=\"$linkurl\"><img src=\"$bannerurl\" width=$bw height=$bh border=0></a><br clear=all>\n";
 print "Wenn der Banner nicht korrekt hier erscheint, URL prfen und Versuch wiederholen..<BR>\n";
 print "<HR size=3 noshade>\n";
 print "<a href=\"$return\">Zurck zum Update Formular</a> | \n";
 print "<A href=\"$member_form\">Member Seite</a> | \n";
 print "<A href=\"$banner_page\">Banner Seite</a>\n";
}

print "<hr size=2><font size=1 face=\"Verdana, Arial\">Banner Manager 1.0F<BR>\n";
print "Copyright \&copy 1997 <a href=\"http://www.meysoft.com\">MeySoft</a><br>\n";
print "bersetzung und Anpassung by <A HREF=\"http://www.inspire-net.de\" TARGET=\"_top\">Inspire-net.de</A></font>\n";
print "</body></html>\n";

}

sub notify{
 open (MAIL,"|$mail_prog -t")||die "Cannot open mail server";
print MAIL "To: $owner_email\n";
print MAIL "From: $owner_email\n";

if($DATA{'delete'} eq 'YES'){
print MAIL "Subject: BANNER ENTFERNT\n\n";
}else{
print MAIL "Subject: Banner Updated\n\n";
}

print MAIL "Account Nr.: $acct_num  Style: $style\n";
if(($password ne $DATA{'newpass'})&&($DATA{'newpass'} ne '')){
print MAIL "Neues Passwort: $DATA{'newpass'} \n encrypted($new_pass) \n Altes Passwort: $password\n";
}
print MAIL "$ext_msg\n";
print MAIL "--------------------------------------------\n";
if($send_env==1){
foreach $field(keys %ENV){
 print MAIL "$field = $ENV{$field}\n";
}
}
print MAIL "\n.\n";
close(MAIL); 
}

sub check_pw{
 $test_pw=crypt($password,substr($encrypt_key,0,2));
 if(!($test_pw eq $pass)){
 $pok=0;
}else{
 $pok=1;
}
}

sub delete_acct{
 open (DBASE,"$acct_dir/$style/$acct_num.dat") || &send_error; 
 while($line=<DBASE>){
   ($user,$mail,$passw,$calls,$hits,$linkurl,$curban,$bannerurl,$a_type)=split(/,/,$line);
   $pass="$passw";
   }
close(DBASE);
if($a_type ne 'deleted'){
open(ACCT,">$acct_dir/$style/$acct_num.dat")|| die "Cannot delete:$!";
print ACCT   "$user,$mail,$passw,$calls,$hits,$linkurl,$curban,$bannerurl,deleted";
close(ACCT);
open(DEL,">>$acct_dir/$style/del.lst");
flock(DEL,2); seek(DEL,0,2);
print DEL "$acct_num\n";
flock(DEL,8);
close(DEL);
}
}

#######################################
sub get_error{
print "Content-type: text/plain\n\n";
print "Fehler beim Banneraufruf in $bannerurl\n";
print "ndern, oder nochmals versuchen\n";
print "Error Code: $!";
exit;
}
#############
sub send_form{
print "Content-type: text/html\n\n";
print <<"WEB_PAGE";
<HTML><HEAD> <TITLE>Update Profile Formular</TITLE></HEAD>
<BODY BGCOLOR="#ffffff" >
<BR>
<CENTER>
<h3>Update Profile Formular</h3>
<HR WIDTH=85%>
<font face="Verdana, Arial" size="2" color="#ff0000"><B> Bitte alle Felder ausfllen fr nderungen.</B><BR>
<B>Unbedingt Account Nr. und Passwort angeben.</B> <BR></font><br>
</CENTER>
<FORM METHOD="POST" ACTION="update.pl">
Account Nummer <INPUT TYPE="text" NAME="acct_num" value="$DATA{'acct_num'}" SIZE=20 MAXLENGTH=20> (######-#)<BR>
 <BR>
Dein Name<BR>
 <INPUT TYPE="text" value="$DATA{'name'}" NAME="name" SIZE=40 MAXLENGTH=60 > <BR>
E-Mail<BR>
 <INPUT TYPE="text" value="$DATA{'email'}" NAME="email" SIZE=50 MAXLENGTH=100> <BR>
Banner URL<BR>
 <INPUT TYPE="text" value="$DATA{'bannerurl'}" NAME="bannerurl" SIZE=50 MAXLENGTH=100><BR>
Link URL<BR>
<INPUT TYPE="text" value="$DATA{'linkurl'}" NAME="linkurl" SIZE=50 MAXLENGTH=100> <BR>
Passwort<BR>
<INPUT TYPE="text" value="$DATA{'password'}" NAME="password" SIZE=20 MAXLENGTH=20> (Pflichtfeld) <BR>
Neues Passwort<BR>
<INPUT TYPE="text" value="$DATA{'newpass'}" NAME="newpass" SIZE=20 MAXLENGTH=20> (Optional) <BR>
 <BR>
<B>Administratoroptionen:</B> 
<BR>
<BR>
<CENTER>
<INPUT TYPE="checkbox" NAME="delete" VALUE="YES" > Lsche Account 
<INPUT TYPE="checkbox" NAME="impressions" VALUE="reset" > Zurcksetzen Anzeige Counter   
<INPUT TYPE="checkbox" NAME="hits" VALUE="reset" > Zurcksetzen Hit Counter  <BR>
</CENTER>
<HR>
<BR>
<CENTER>
<INPUT TYPE="submit" value="Update"><INPUT TYPE="reset" value="Abbrechen">
</CENTER>
</FORM>
<CENTER>
<font face="Verdana, Arial" size="2"><B>[<A href="banners.html">Zurck zur Hauptseite</a>]</B></font>
</CENTER>
<hr size=2>

<hr size=2><font size=1 face="Verdana, Arial">Banner Manager 1.0F<BR>
Copyright &copy 1997 <a href="http://www.meysoft.com">MeySoft</a><br>
bersetzung und Anpassung by <A HREF="http://www.inspire-net.de" TARGET="_top">Inspire-net.de</A></font>

</BODY></HTML>
WEB_PAGE
exit;
}

################################################
# EOS Last Update: July 9, 1997 Jeffrey L. Meyer