#!/usr/bin/perl

require "banman10.pl";

##############################################
# MeySoft BannerManager - badmin.pl
# BASIC PACKAGE - VERSION: 1.0-F Rev. July 9, 1997
# Copyright (c) 1997 MeySoft
# Author: Jeffrey L. Meyer, Sr.Programmer
# WebMaster@MeySoft.com
###############################################
# THIS SOFTWARE PRODUCT IS LICENSED FOR USE
# ON A SINGLE SERVER ONLY. ANY OTHER USE IS
# IN DIRECT VIOLATION OF US AND INTERNATIONAL
# COPYRIGHT LAWS. ALL COPYRIGHT NOTICES MUST
# REMAIN INTACT. A LINK TO OUR SITE IS REQUIRED!
###############################################
# THIS HEADER MUST REMAIN INTACT
##############################################
alarm(10);

@slist=split(/,/,$banman10{'slist'});
$mail_prog="$banman10{'mail_prog'}";
$owner_email="$banman10{'owner_email'}";
$acct_dir="$banman10{'acct_dir'}";
$banner_page="$banman10{'banner_page'}";
$your_name="$banman10{'xchange_title'}";
$default_ban_path="$banman10{'default_ban_path'}";
$return="$banman10{'admin_form'}";
$home_page="$banman10{'home_page'}";
$encrypt_key="$banman10{'encrypt_key'}";
############################################################

if($ENV{'REQUEST_METHOD'} eq 'POST'){
read(STDIN,$data,$ENV{'CONTENT_LENGTH'});
}else{
$data="$ENV{'QUERY_STRING'}";
}
@fields = split(/&/,$data);
foreach $fields(@fields){
  ($field_name,$field_val)=split(/=/,$fields);
  $field_val=~ tr/+/ /;
  $field_val=~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
 $DATA{$field_name}=$field_val;
}

if($DATA{'acctnum'}){
($acct_num,$sf)=split(/-/,$DATA{'acctnum'});
$style=$slist[$sf-1]; #always used except pwchange
}else{
 $style="$DATA{'style'}";
 }
$cnt=0;
foreach $st(@slist){
 if($style eq $st){
   $cnt++; 
   $kc="$cnt";
 }else{
 $cnt++;
}
}

$command="$DATA{'command'}"; #always used
$password="$DATA{'password'}"; #always used
$newpass="$DATA{'newpass'}"; #only valid if changing
&check_pw;

if($pok != 1){
&invalid_pass;
exit;
}

######################################
#CHECK COMMANDS
if(!($DATA{'command'})){
 &send_header;
 print "<H2>Kein Kommando gewhlt...</h2>\n";
}
if($command eq 'Delete User Account'){
&check_no;
&del_user;
}
if($command eq 'Hold User Account'){
&check_no;
&hold_acct;
}
if($command eq 'Activate User Account'){
&check_no;
&activate;
}
if($command eq 'List Users'){
$style="$DATA{'style'}";
&list_users;
}
if($command eq 'Create Style Databases'){
$style="$DATA{'style'}";
&create_style;
}
if($command eq 'Get User Stats'){
&check_no;
&get_user_stats;
}

if($command eq 'Change Admin Password'){
&change_pw;
}
###########
&send_footer;
exit;
###################
# END#
######

#########################
sub create_style{
&send_header;

$ec=mkdir($acct_dir,0777);
if($ec==1){
 `chmod 777 $acct_dir`;
 print "<B>Datenbank Verzeichnis</B> \'$acct_dir\' <B>existiert nicht, muss erstellt werden...</B><BR>\n";
}
chdir($acct_dir);

$ec=mkdir($style,0777);
if($ec==1){
 `chmod 777 $style`;
 print "<B>Datenbank Verzeichnis</B> \'$acct_dir/$style\' <B>existiert nicht, muss erstellt werden...</B><BR>\n";
}
chdir("..");

########################################
$no_error=1;
open(ACCT,">$acct_dir/$style/0.dat")|| &send_error("Could not create $acct_dir/$style/0.dat :$!");
 print ACCT "$your_name,$owner_email,$pass,0,0,$home_page,1,$default_ban_path,swap";
close(ACCT);
`chmod 766 $acct_dir/$style/0.dat`;
if($no_error){ print "Standard Banner Account erstellt<BR>\n";}

if(!(-e "$acct_dir/$style/last_rec.ord")){
open(LR,">$acct_dir/$style/last_rec.ord")||&send_error("Could not create $acct_dir/$style/last_rec.ord :$!");
print LR "0";
close(LR);
`chmod 766 $acct_dir/$style/last_rec.ord`;
}
if($no_error){ print "last_rec.ord   -Created and preset to 0<BR>\n"; }

#DELETE LIST
 if(!(-e "$acct_dir/$style/del.lst")){
  open(DEL,">$acct_dir/$style/del.lst");
  print DEL "\n";
  close(DEL);
  `chmod 766 $acct_dir/$style/del.lst`;
}
&get_last;
$cur=1;
$no_error=1;
open(BAN,">$acct_dir/$style/current.ban")||&send_error("Cannot create $style/current.ban :$!");
  print BAN "0";
close(BAN);
`chmod 766 $acct_dir/$style/current.ban`;
if($no_error){ print "current.ban   -Created and preset to 0<BR>\n"; }
$no_error=1;

}
#####################
sub get_user_stats{
&get_acct_data;
&send_header;
$ext=substr($bannerurl,rindex($bannerurl,".")+1);
print <<"WEB_PAGE";
Statistik fr Account Nummer: $DATA{'acctnum'}
<P>
Username: $user<BR>
E-Mail: <a href="mailto:$mail">$mail</a><BR>
Passwort -entschlsselt-: $passw<BR>
Impressions: $calls<BR>
Bannerklicks: $hits<BR>
Link URL: <a href="$linkurl">$linkurl</a><BR>
Banner URL: <a href="$bannerurl">$bannerurl</a> <BR>
WEB_PAGE
}
##################################
sub del_user{
 open (DBASE,"$acct_dir/$style/$acct_num.dat") ||&post_error;
 while($line=<DBASE>){
   ($user,$mail,$passw,$calls,$hits,$linkurl,$curban,$bannerurl,$a_type)=split(/,/,$line);
  }
close(DBASE);
if($a_type ne 'deleted'){
open(ACCT,">$acct_dir/$style/$acct_num.dat")|| &post_error;
flock(ACCT,2); seek(ACCT,0,2);
print ACCT "$user,$mail,$passw,$calls,$hits,$linkurl,$curban,$bannerurl,deleted";
flock(ACCT,8);
close(ACCT);
open(DEL,">>$acct_dir/$style/del.lst");
flock(DEL,2); seek(DEL,0,2);
print DEL "$acct_num\n";
flock(DEL,8);
close(DEL);
&send_header;
print "User Account $acct_num - $kc entfernt...\n";
}else{
&send_header;
print "User account $acct_num - $kc schon entfernt...\n";
}
}

###############
sub hold_acct{
 open (DBASE,"$acct_dir/$style/$acct_num.dat") ||&post_error;
 while($line=<DBASE>){
   ($user,$mail,$passw,$calls,$hits,$linkurl,$curban,$bannerurl,$a_type)=split(/,/,$line);
  }
close(DBASE);

open(ACCT,">$acct_dir/$style/$acct_num.dat")|| &post_error;
flock(ACCT,2); seek(ACCT,0,2);
#if already set, reset
 if($a_type eq 'swaphold'){ $a_type="swap"; }
$a_type .="hold";

print ACCT "$user,$mail,$passw,$calls,$hits,$linkurl,$curban,$bannerurl,$a_type";
flock(ACCT,8);
close(ACCT);
&send_header;
print "User account $acct_num - $kc on hold\n";
}

#################
sub activate{
 open (DBASE,"$acct_dir/$style/$acct_num.dat") ||&post_error;
 while($line=<DBASE>){
   ($user,$mail,$passw,$calls,$hits,$linkurl,$curban,$bannerurl,$a_type)=split(/,/,$line);
  }
close(DBASE);
 if($a_type eq 'swaphold'){ $a_type="swap"; }

open(ACCT,">$acct_dir/$style/$acct_num.dat")|| &post_error;
flock(ACCT,2); seek(ACCT,0,2);
print ACCT "$user,$mail,$passw,$calls,$hits,$linkurl,$curban,$bannerurl,$a_type";
flock(ACCT,8);
close(ACCT);
`chmod 777 $acct_dir/$style/$acct_num.dat`;
&send_header;
print "User: $user Account: $acct_num - $kc aktiviert als: $a_type\n";
}


#####################
sub list_users{
&get_last;
$start_rec="$DATA{'rangeLo'}";
$end_rec="$DATA{'rangeHi'}";
if(($start_rec <0)||($last >$start_rec)){
  $start_rec=0; 
}
if($end_rec <0){
 $end_rec=0; 
}
  if(($end_rec eq 'ALL')||($end_rec eq 'all')||($end_rec eq 'All')||($end_rec eq 'last')){
  $end_rec=$last; 
}
  if($end_rec > $last){ 
 $end_rec=$last; 
}
  if($end_rec <=0){ 
 $end_rec=0; 
}
&send_header;
  print "Hier ist die Mitgliederliste fr $style Style: Es sind insgesamt $last Mitglieder mit diesem Bannestyle<P>\n";
$cur=$start_rec;
print "<table border=1>\n";
print "<TR><TD>Acct Nr.</td><td>Name &amp LinkURL</td><td>E-Mail</td><TD>Banner</td><td>Status</td>";
print "<td>Imp</td><td>Hits</td></tr>\n";

  while($cur <=$end_rec){
    $no_error=1;
    $acct_num=$cur;
    &get_acct_data;
    if($no_error){
    $ext=substr($bannerurl,rindex($bannerurl,".")+1);
    $img_url="$bannerurl";
     print "<TR><TD>$acct_num - $kc</td>";
     print "<TD><a href=\"$linkurl\">$user</a></TD><TD><a href=\"mailto: $mail\">SEND</a></td><TD><a href=\"$img_url\">Show Banner</a></td><td>$a_type</TD>";
     print "<td>$calls</td><td>$hits</td></tr>\n";
    }

#
# IF YOU WANT TO ADD OTHER FIELDS TO THE OUTPUT
# PLACE IN THE PRINT STATEMENT ABOVE
#
$cur++;
}
print "</table>\n";
}

#################
sub get_acct_data {
 open (DBASE,"$acct_dir/$style/$acct_num.dat") ||&send_error("Could not open $acct_dir/$style/$acct_num.dat"); 
 while($line=<DBASE>){
($user,$mail,$passw,$calls,$hits,$linkurl,$curban,$bannerurl,$a_type)=split(/,/,$line);
$pass="$passw";
}
 close(DBASE);
}

######################
sub save_acct_data{
open (DBASE,">$acct_dir/$style/$acct_num.dat") || &send_error("Could not open $acct_dir/$style/$acct_num.dat"); 
flock(DBASE,2); seek(DBASE,0,2);
print DBASE "$user,$mail,$passw,$calls,$hits,$linkurl,$curban,$bannerurl,$a_type";
flock(DBASE,8);
close(DBASE);
}


#####################
sub get_last{
open(LAST,"$acct_dir/$style/last_rec.ord") || &send_error("Could not open last_rec.ord");
$last=<LAST>;
close(LAST);
}
#############
sub send_error{
  local($error_code)=@_;
$no_error=0;
print "Error: $error_code<BR> \n";
}
#############
sub post_error{
print "There was an error executing; \[ $command \] \n";
print "Error: $! \n";
}
###############
sub check_refer{
$refer_ok=0;
foreach $refer(@referers){
if($refer eq $ENV{'HTTP_REFERER'}){
$refer_ok=1;
}
}
}
################
sub check_pw{
open(PW,"pw.dat");
$pass=<PW>;
close(PW);
 $test_pw=crypt($password,substr($encrypt_key,0,2));
 if(!($test_pw eq $pass)){
 $pok=0;
 &invalid_pass;
}else{
 $pok=1;
}
}
###################
sub invalid_pass{
&send_header;
print "Falsches Admin Passwort: \'$password\' \n\n";
exit;
}
##################
sub change_pw{
$np=crypt($newpass,substr($encrypt_key,0,2));
open(PW,">pw.dat");
print PW "$np";
close(PW);
print "Location: $return\n\n";
exit;
}
################
sub get_error{
&send_header;
print "Banner URL nicht OK: <a href=\"$url\">$url</a><BR>\n";
print "Bitte nochmal versuchen, oder Bannerlink in der User Statistik prfen.<BR>\n";
print "Error Code: $! <BR>";
print "$outfile<BR>\n";
&send_footer;
exit;
}
#############################
sub send_header{
print "Content-type: text/html\n\n";
print "<HTML><HEAD><TITLE>Admin - Resultat</TITLE><basefont size=2></HEAD>\n";
print "<BODY bgcolor=\"ffffff\">\n";
print "<h3><B>ADMIN RESULTATE FR: </B><I>$command </I></h3><P><hr size=4>\n\n";
}
##############
sub send_footer{
print "<hr size=4><BR>DONE\n";
print "<P><A href=\"$return\">Zurck zum Admin Formular</a>\n";

print "<hr size=2><font size=1 face=\"Verdana, Arial\">Banner Manager 1.0F<BR>\n";
print "Copyright \&copy 1997 <a href=\"http://www.meysoft.com\">MeySoft</a><br>\n";
print "bersetzung und Anpassung by <A HREF=\"http://www.inspire-net.de\" TARGET=\"_top\">Inspire-net.de</A></font>\n";
print "</body></html>\n";
}

########################
sub check_no{
&get_last;
if($acct_num > $last){
&send_header;
&send_error("Falsche Account Nummer $acct_num - $kc\n");
&send_footer;
exit;
}
}
##############################################################
# EOS Last Update: July 9, 1997 Jeffrey L. Meyer