#!/usr/bin/perl

require "banman10.pl";

##############################################
# MeySoft BannerManager - memstats.pl
# BASIC PACKAGE - VERSION: 1.0-F Rev. July 9, 1997
# Copyright (c) 1997 MeySoft
# Author: Jeffrey L. Meyer, Sr.Programmer
# WebMaster@MeySoft.com
###############################################
# THIS SOFTWARE PRODUCT IS LICENSED FOR USE
# ON A SINGLE SERVER ONLY. ANY OTHER USE IS
# IN DIRECT VIOLATION OF US AND INTERNATIONAL
# COPYRIGHT LAWS.
###############################################
# THIS HEADER MUST REMAIN INTACT
##############################################
@slist=split(/,/,$banman10{'slist'});
$owner_email="$banman10{'owner_email'}";
$mail_prog="$banman10{'mail_prog'}";
$redirect="$banman10{'redirect'}";
$barimage="$banman10{'barimage'}";
$notify_checked=$banman10{'notify_checked'};
$send_env=$banman10{'send_env'};
$acct_dir="$banman10{'acct_dir'}";
$banner_page="$banman10{'banner_page'}";
$home_page="$banman10{'home_page'}";
$banner_button="$banman10{'banner_button'}";
$link_title="$banman10{'link_title'}";
$alt_text="$banman10{'alt_text'}";
$encrypt_key="$banman10{'encrypt_key'}";
$return="$banman10{'member_page'}";
$member_page="$banman10{'member_page'}";
$update_page="$banman10{'update_page'}";

######################################
read(STDIN,$data,$ENV{'CONTENT_LENGTH'});
@fields = split(/&/,$data);
foreach $fields(@fields){
  ($field_name,$field_val)=split(/=/,$fields);
  $field_val=~ tr/+/ /;
  $field_val=~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
 $DATA{$field_name}=$field_val;
}

if($DATA{'password'}){
 $password="$DATA{'password'}";
}else{
 $ext_msg .="Fehlendes passwort,";
 &no_acct;
exit;
}

($acct_num,$sf)=split(/-/,$DATA{'acct_num'});
$style=$slist[$sf-1];

if (!$DATA{'acct_num'}){
 $ext_msg .="Fehlende Account Nummer,";
 &no_acct;
}

$pok=0;
($bw,$bh)=split(/x/,$style);

&get_acct_data;
&check_pw;
  if($pok==1){
     if($notify_checked==1){ 
       &notify; 
     }
   &send_it;
 }else{
   $ext_msg .="Falsches Passwort,";
   &no_acct;
 }
exit;

#=====================================================#
sub get_acct_data {
 open (DBASE,"$acct_dir/$style/$acct_num.dat") || &send_error; 
 while($line=<DBASE>){
 ($user,$mail,$passw,$calls,$hits,$linkurl,$curban,$imageurl,$a_type)=split(/,/,$line);
 $pass="$passw";
 }
 close(DBASE);
}

#=====================================================#
sub send_it {
 print "Content-type: text/html\n\n";
 print "<HEAD><TITLE>Banner Ad Statistik</TITLE></HEAD><BODY bgcolor=\"ffffff\">\n";
 print "Banner Ad Statistik fr Account Nr.: $acct_num <P>\n";
 print "Name: $user <BR>\n";
 print "E-Mail: $mail <BR>\n";
 print "Banner URL: $imageurl<BR>\n";
 print "Link URL: $linkurl<BR>\n";
 print "<P>\n";
 print "Gesamte Impressionen auf anderen Seiten: $calls <BR>\n";
 print "Anzahl der Bannerklicks auf anderen Seiten: $hits <BR>\n";

if($calls !=0){
$ratio=($hits / $calls) *100;
}else{
$ratio=0;
}
$s_r="$ratio";
$s_ratio=substr($s_r,0,4);
 print "Ratio von Hits zu Anzeige: $s_ratio \%<BR>\n";
 print "<HR SIZE=3 NOSHADE>\n";
 print "<a href=\"$linkurl\"><img src=\"$imageurl\" border=0 width=$bw height=$bh></a><br clear=all>\n";
 print "<HR size=3 noshade>\n";
 print "Hier ist der HTML Code der in die Seite eingebaut werden muss:<BR><BR>\n";
 print "<XMP>\n";
 print "<!-- BEGIN BANNER CODE -->\n<P><CENTER>\n";
 print "<a href=\"$banner_page\">\n";
 print "<img src=\"$banner_button\" width=$bh \n";
 print "height=$bh border=0 hspace=0 vspace=0></a>\n";
 print "<A HREF=\"$redirect?a=$acct_num&s=$style\" >\n";
 print "<IMG SRC=\"$barimage?a=$acct_num&s=$style\" \n WIDTH=$bw height=$bh \n";
 print "BORDER=0  ALIGN=top HSPACE=0 VSPACE=0  \n ALT=\"$alt_text\"></A> \n";
 print "<BR CLEAR=ALL>";
 print "<FONT SIZE=-1>\n<A HREF=\"$banner_page\" >\n";
 print "$link_title</A></FONT>\n";
 print "</table></CENTER></P>\n";
 print "<!-- END BANNER CODE -->\n</XMP>\n";

 print "<HR SIZE=3 NOSHADE>\n";
 print "<a href=\"$update_page\">Profilupdate</a> | \n";
 print "<A href=\"$return\">Mitglieder Seite</a> | \n";
 print "<A href=\"$banner_page\">Banner Seite</a>\n";

print "<hr size=2><font size=1 face=\"Verdana, Arial\">Banner Manager 1.0F<BR>\n";
print "Copyright \&copy 1997 <a href=\"http://www.meysoft.com\">MeySoft</a><br>\n";
print "bersetzung und Anpassung by <A HREF=\"http://www.inspire-net.de\" TARGET=\"_top\">Inspire-net.de</A></font>\n";
print "</body></html>\n";
}
#=====================================================#
sub send_error {
 print "Content-type: text/html\n\n";
 print "<HEAD><TITLE>Banner Ad Statistik</TITLE></HEAD><BODY>\n";
 print "Fehler im Formular. Bitte eingetragene Daten prfen und korrigieren.<BR>\n";
 print "Fehlermeldung: $! Fr Account: \'$DATA{'acct_num'}\' in $style \n";
 print "<HR SIZE=3 NOSHADE>\n";
 print "<A href=\"$member_page\">Zurck</a>\n";
 print "</BODY>\n";
exit;
}
#=====================================================#
sub invalid_pass {
 print "Content-type: text/html\n\n";
 print "<HEAD><TITLE>Banner Ad Statistik</TITLE></HEAD><BODY>\n";
 print "Falsches Passwort \'$password\' <BR>\n";

 print "<HR SIZE=3 NOSHADE>\n";
 print "<A href=\"$member_page\">Zurck zum Formular</a>\n";
 print "</BODY>\n";
exit;
}
#=====================================================#
sub notify{
open (MAIL,"|$mail_prog -t")||die "Cannot open mail server: $!";
print MAIL "To: $owner_email\n";
print MAIL "From: $owner_email\n";
print MAIL "Subject: Banner Statistik geprft\n\n";
print MAIL "$user,$email\n";
print MAIL "$acct_num - $sf\n";
print MAIL "$password\n";
print MAIL "Noch offen: \$ $a_bal\n";
print MAIL "--------------------------------------------\n";
if($send_env==1){
foreach $field(keys %ENV){
print MAIL "$field=$ENV{$field}\n";
}}
print MAIL "\n.\n";
close(MAIL); 
}
#=====================================================#
sub check_pw{
 $test_pw=crypt($password,substr($encrypt_key,0,2));
 if(!($test_pw eq $pass)){
 $pok=0;
}else{
 $pok=1;
}
}
#=====================================================#
sub no_acct {
 print "Content-type: text/html\n\n";
print <<"WEB_FORM";
<HEAD><TITLE>Fehler aufgetreten</TITLE></HEAD>
<BODY BGCOLOR="#ffffff">
</HEAD>
<h3>Member Statistik und Profile</h3>
<HR SIZE=2 NOSHADE>
Account Nummer und Passwort sind Pflichtfelder (Schreibweise genau einhalten)<P>
<font color="ff0000">$ext_msg</font>
<BR>
<FORM METHOD="POST" ACTION="memstats.pl">
Account Nummer <INPUT TYPE="text" NAME="acct_num" value="$DATA{'acct_num'}" size=20 maxlength=20> <BR>
Passwort <INPUT TYPE="password" name="password" value="$DATA{'password'}" size=20 maxlength=20> Schreibweise genau einhalten
<P>
<CENTER>
<INPUT TYPE="submit" value="Get Stats"><INPUT TYPE="reset" value="Abbrechen">
 <BR>
</CENTER>
</FORM>
<HR SIZE=2 NOSHADE>
<CENTER>
<A href="$update_page">Profil updaten</a> | 
<A href="$banner_page">Zurck zur Banner Seite</a> |
<a href="$home_page" target="_top">Home Page</a>
</CENTER>

<font size=1 face="Verdana, Arial">Banner Manager 1.0F<BR>
Copyright &copy 1997 <a href="http://www.meysoft.com">MeySoft</a><br>
bersetzung und Anpassung by <A HREF="http://www.inspire-net.de" TARGET="_top">Inspire-net.de</A></font>
</BODY></HTML>
WEB_FORM
exit;
}
############################################
# EOS Last Update: July 9, 1997 Jeffrey L. Meyer